Index: palm/trunk/SOURCE/data_output_netcdf4_module.f90
===================================================================
--- palm/trunk/SOURCE/data_output_netcdf4_module.f90	(revision 4596)
+++ palm/trunk/SOURCE/data_output_netcdf4_module.f90	(revision 4597)
@@ -24,4 +24,10 @@
 ! -----------------
 ! $Id$
+! bugfix: - allow writing of unlimited dimensions in parallel mode
+!         - prevent unused-variable warning if preprocessor directives are not given
+! change: - set parallel access mode to independent per default
+! new   : - dimension variables can be written by every PE
+!
+! 4579 2020-06-25 20:05:07Z gronemeier
 ! corrected formatting to follow PALM coding standard
 !
@@ -53,4 +59,7 @@
 !> NetCDF output module to write data to NetCDF files.
 !> This is either done in parallel mode via parallel NetCDF4 I/O or in serial mode only by PE0.
+!>
+!> @bug 'mode' is not always checked. If a routine is called with an unknown mode (e.g. a typo),
+!>      this does not throw any error.
 !--------------------------------------------------------------------------------------------------!
  MODULE data_output_netcdf4_module
@@ -82,4 +91,5 @@
     INTEGER ::  global_id_in_file = -1  !< value of global ID within a file
     INTEGER ::  master_rank             !< master rank for tasks to be executed by single PE only
+    INTEGER ::  my_rank                 !< MPI rank of processor
     INTEGER ::  output_group_comm       !< MPI communicator addressing all MPI ranks which participate in output
 
@@ -150,4 +160,6 @@
                                  program_debug_output_unit, debug_output, dom_global_id )
 
+    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'netcdf4_init_module'  !< name of this routine
+
     CHARACTER(LEN=*), INTENT(IN) ::  file_suffix_of_output_group  !> file-name suffix added to each file;
                                                                   !> must be unique for each output group
@@ -157,4 +169,5 @@
     INTEGER, INTENT(IN) ::  mpi_comm_of_output_group   !< MPI communicator specifying the rank group participating in output
     INTEGER, INTENT(IN) ::  program_debug_output_unit  !< file unit number for debug output
+    INTEGER             ::  return_value               !< return value
 
     LOGICAL, INTENT(IN) ::  debug_output  !< if true, debug output is printed
@@ -165,4 +178,17 @@
     master_rank = master_output_rank
 
+#if defined( __parallel )
+    CALL MPI_COMM_RANK( output_group_comm, my_rank, return_value )
+    IF ( return_value /= 0 )  THEN
+       CALL internal_message( 'error', routine_name // ': MPI_COMM_RANK error' )
+    ENDIF
+#else
+    my_rank = master_rank
+    return_value = 0
+!
+!-- Dummy commands to prevent "unused-variable" warning if preprocessor is not set
+    IF ( .FALSE. )  CALL internal_message( 'debug', routine_name // ': dummy message' )
+#endif
+
     debug_output_unit = program_debug_output_unit
     print_debug_output = debug_output
@@ -185,5 +211,4 @@
 
     INTEGER, INTENT(OUT) ::  file_id       !< file ID
-    INTEGER              ::  my_rank       !< MPI rank of processor
     INTEGER              ::  nc_stat       !< netcdf return value
     INTEGER, INTENT(OUT) ::  return_value  !< return value
@@ -199,24 +224,14 @@
 
 #if defined( __netcdf4 )
-#if defined( __parallel )
-       CALL MPI_COMM_RANK( output_group_comm, my_rank, return_value )
-       IF ( return_value /= 0 )  THEN
-          CALL internal_message( 'error', routine_name // ': MPI_COMM_RANK error' )
-       ENDIF
-       IF ( my_rank /= master_rank )  THEN
-          return_value = 1
-          CALL internal_message( 'error', routine_name //                                          &
-                                 ': trying to define a NetCDF file in serial mode by an MPI ' //   &
-                                 'rank other than the master output rank. Serial NetCDF ' //       &
-                                 'files can only be defined by the master output rank!' )
-       ENDIF
-#else
-       my_rank = master_rank
-       return_value = 0
-#endif
-
-       IF ( return_value == 0 )                                                                    &
-          nc_stat = NF90_CREATE( TRIM( file_name ) // TRIM( file_suffix ),                         &
-                                 IOR( NF90_NOCLOBBER, NF90_NETCDF4 ), file_id )
+
+       IF ( return_value == 0 )  THEN
+          IF ( my_rank == master_rank )  THEN
+             nc_stat = NF90_CREATE( TRIM( file_name ) // TRIM( file_suffix ),                      &
+                                    IOR( NF90_NOCLOBBER, NF90_NETCDF4 ),                           &
+                                    file_id )
+          ELSE
+             nc_stat = 0
+          ENDIF
+       ENDIF
 #else
        nc_stat = 0
@@ -245,7 +260,7 @@
        nc_stat = 0
        return_value = 1
-       CALL internal_message( 'error', routine_name // ': selected mode "' //                      &
-                                       TRIM( mode ) // '" must be either "' //                     &
-                                       mode_serial // '" or "' // mode_parallel // '"' )
+       CALL internal_message( 'error', routine_name //                                             &
+                              ': selected mode "' // TRIM( mode ) // '" must be either "' //       &
+                              mode_serial // '" or "' // mode_parallel // '"' )
     ENDIF
 
@@ -266,5 +281,5 @@
 !> Write attribute to netcdf file.
 !--------------------------------------------------------------------------------------------------!
- SUBROUTINE netcdf4_write_attribute( file_id, variable_id, attribute_name,                         &
+ SUBROUTINE netcdf4_write_attribute( mode, file_id, variable_id, attribute_name,                   &
                                      value_char, value_int8, value_int16, value_int32,             &
                                      value_real32, value_real64, return_value )
@@ -273,4 +288,5 @@
 
     CHARACTER(LEN=*), INTENT(IN)           ::  attribute_name  !< name of attribute
+    CHARACTER(LEN=*), INTENT(IN)           ::  mode            !< operation mode (either parallel or serial)
     CHARACTER(LEN=*), INTENT(IN), OPTIONAL ::  value_char      !< value of attribute
 
@@ -292,41 +308,52 @@
     return_value = 0
 
-    IF ( variable_id == global_id_in_file )  THEN
-       target_id = NF90_GLOBAL
-    ELSE
-       target_id = variable_id
-    ENDIF
-
-    CALL internal_message( 'debug', routine_name //                                                &
-                           ': write attribute "' // TRIM( attribute_name ) // '"' )
-
-    IF ( PRESENT( value_char ) )  THEN
-       nc_stat = NF90_PUT_ATT( file_id, target_id, TRIM( attribute_name ), TRIM( value_char ) )
-    ELSEIF ( PRESENT( value_int8 ) )  THEN
-       nc_stat = NF90_PUT_ATT( file_id, target_id, TRIM( attribute_name ), value_int8 )
-    ELSEIF ( PRESENT( value_int16 ) )  THEN
-       nc_stat = NF90_PUT_ATT( file_id, target_id, TRIM( attribute_name ), value_int16 )
-    ELSEIF ( PRESENT( value_int32 ) )  THEN
-       nc_stat = NF90_PUT_ATT( file_id, target_id, TRIM( attribute_name ), value_int32 )
-    ELSEIF ( PRESENT( value_real32 ) )  THEN
-       nc_stat = NF90_PUT_ATT( file_id, target_id, TRIM( attribute_name ), value_real32 )
-    ELSEIF ( PRESENT( value_real64 ) )  THEN
-       nc_stat = NF90_PUT_ATT( file_id, target_id, TRIM( attribute_name ), value_real64 )
-    ELSE
-       return_value = 1
-       CALL internal_message( 'error', routine_name //                                             &
-                              ': no value given for attribute "' // TRIM( attribute_name ) // '"' )
-    ENDIF
-
-    IF ( return_value == 0 )  THEN
-       IF ( nc_stat /= NF90_NOERR )  THEN
+    IF ( .NOT. ( TRIM( mode ) == mode_serial  .AND.  my_rank /= master_rank ) )  THEN
+
+       IF ( variable_id == global_id_in_file )  THEN
+          target_id = NF90_GLOBAL
+       ELSE
+          target_id = variable_id
+       ENDIF
+
+       CALL internal_message( 'debug', routine_name //                                             &
+                              ': write attribute "' // TRIM( attribute_name ) // '"' )
+
+       IF ( PRESENT( value_char ) )  THEN
+          nc_stat = NF90_PUT_ATT( file_id, target_id, TRIM( attribute_name ), TRIM( value_char ) )
+       ELSEIF ( PRESENT( value_int8 ) )  THEN
+          nc_stat = NF90_PUT_ATT( file_id, target_id, TRIM( attribute_name ), value_int8 )
+       ELSEIF ( PRESENT( value_int16 ) )  THEN
+          nc_stat = NF90_PUT_ATT( file_id, target_id, TRIM( attribute_name ), value_int16 )
+       ELSEIF ( PRESENT( value_int32 ) )  THEN
+          nc_stat = NF90_PUT_ATT( file_id, target_id, TRIM( attribute_name ), value_int32 )
+       ELSEIF ( PRESENT( value_real32 ) )  THEN
+          nc_stat = NF90_PUT_ATT( file_id, target_id, TRIM( attribute_name ), value_real32 )
+       ELSEIF ( PRESENT( value_real64 ) )  THEN
+          nc_stat = NF90_PUT_ATT( file_id, target_id, TRIM( attribute_name ), value_real64 )
+       ELSE
           return_value = 1
           CALL internal_message( 'error', routine_name //                                          &
-                                 ': NetCDF error while writing attribute "' //                     &
-                                 TRIM( attribute_name ) // '": ' // NF90_STRERROR( nc_stat ) )
-       ENDIF
+                                 ': no value given for attribute "' // TRIM( attribute_name ) //   &
+                                 '"' )
+       ENDIF
+
+       IF ( return_value == 0 )  THEN
+          IF ( nc_stat /= NF90_NOERR )  THEN
+             return_value = 1
+             CALL internal_message( 'error', routine_name //                                       &
+                                    ': NetCDF error while writing attribute "' //                  &
+                                    TRIM( attribute_name ) // '": ' // NF90_STRERROR( nc_stat ) )
+          ENDIF
+       ENDIF
+
     ENDIF
 #else
     return_value = 1
+!
+!-- Dummy commands to prevent "unused-variable" warning if preprocessor is not set
+    IF ( .FALSE. )  THEN
+       nc_stat = LEN( routine_name )
+       target_id = 0
+    ENDIF
 #endif
 
@@ -339,5 +366,6 @@
 !--------------------------------------------------------------------------------------------------!
  SUBROUTINE netcdf4_init_dimension( mode, file_id, dimension_id, variable_id,                      &
-                                    dimension_name, dimension_type, dimension_length, return_value )
+                                    dimension_name, dimension_type, dimension_length,              &
+                                    write_only_by_master_rank, return_value )
 
     CHARACTER(LEN=*), PARAMETER ::  routine_name = 'netcdf4_init_dimension'  !< name of this routine
@@ -355,33 +383,42 @@
     INTEGER, INTENT(OUT) ::  variable_id          !< variable ID
 
+    LOGICAL, INTENT(IN) ::  write_only_by_master_rank  !< true if only master rank shall write variable
+
 
 #if defined( __netcdf4 )
     return_value = 0
     variable_id = -1
-
-    CALL internal_message( 'debug', routine_name //                                                &
-                           ': init dimension "' // TRIM( dimension_name ) // '"' )
-!
-!-- Check if dimension is unlimited
-    IF ( dimension_length < 0 )  THEN
-       nc_dimension_length = NF90_UNLIMITED
-    ELSE
-       nc_dimension_length = dimension_length
-    ENDIF
-!
-!-- Define dimension in file
-    nc_stat = NF90_DEF_DIM( file_id, dimension_name, nc_dimension_length, dimension_id )
-
-    IF ( nc_stat == NF90_NOERR )  THEN
-!
-!--    Define variable holding dimension values in file
-       CALL netcdf4_init_variable( mode, file_id, variable_id, dimension_name, dimension_type,     &
-                                   (/ dimension_id /), is_global=.TRUE., return_value=return_value )
-
-    ELSE
-       return_value = 1
-       CALL internal_message( 'error', routine_name //                                             &
-                              ': NetCDF error while initializing dimension "' //                   &
-                              TRIM( dimension_name ) // '": ' // NF90_STRERROR( nc_stat ) )
+    dimension_id = -1
+
+    IF ( .NOT. ( TRIM( mode ) == mode_serial  .AND.  my_rank /= master_rank ) )  THEN
+
+       CALL internal_message( 'debug', routine_name //                                             &
+                              ': init dimension "' // TRIM( dimension_name ) // '"' )
+!
+!--    Check if dimension is unlimited
+       IF ( dimension_length < 0 )  THEN
+          nc_dimension_length = NF90_UNLIMITED
+       ELSE
+          nc_dimension_length = dimension_length
+       ENDIF
+!
+!--    Define dimension in file
+       nc_stat = NF90_DEF_DIM( file_id, dimension_name, nc_dimension_length, dimension_id )
+
+       IF ( nc_stat == NF90_NOERR )  THEN
+!
+!--       Define variable holding dimension values in file
+          CALL netcdf4_init_variable( mode, file_id, variable_id, dimension_name, dimension_type,  &
+                                      (/ dimension_id /),                                          &
+                                      write_only_by_master_rank=write_only_by_master_rank,         &
+                                      return_value=return_value )
+
+       ELSE
+          return_value = 1
+          CALL internal_message( 'error', routine_name //                                          &
+                                 ': NetCDF error while initializing dimension "' //                &
+                                 TRIM( dimension_name ) // '": ' // NF90_STRERROR( nc_stat ) )
+       ENDIF
+
     ENDIF
 #else
@@ -389,4 +426,10 @@
     variable_id = -1
     dimension_id = -1
+!
+!-- Dummy commands to prevent "unused-variable" warning if preprocessor is not set
+    IF ( .FALSE. )  THEN
+       nc_stat = LEN( routine_name )
+       nc_dimension_length = 0
+    ENDIF
 #endif
 
@@ -399,5 +442,5 @@
 !--------------------------------------------------------------------------------------------------!
  SUBROUTINE netcdf4_init_variable( mode, file_id, variable_id, variable_name, variable_type,       &
-                                   dimension_ids, is_global, return_value )
+                                   dimension_ids, write_only_by_master_rank, return_value )
 
     CHARACTER(LEN=*), PARAMETER ::  routine_name = 'netcdf4_init_variable'  !< name of this routine
@@ -407,53 +450,77 @@
     CHARACTER(LEN=*), INTENT(IN) ::  variable_type  !< data type of variable
 
-    INTEGER, INTENT(IN)  ::  file_id           !< file ID
-    INTEGER              ::  nc_stat           !< netcdf return value
-    INTEGER              ::  nc_variable_type  !< netcdf data type
-    INTEGER, INTENT(OUT) ::  return_value      !< return value
-    INTEGER, INTENT(OUT) ::  variable_id       !< variable ID
-
+    INTEGER, INTENT(IN)  ::  file_id                 !< file ID
+    INTEGER              ::  nc_stat                 !< netcdf return value
+    INTEGER              ::  nc_variable_type        !< netcdf data type
+    INTEGER, INTENT(OUT) ::  return_value            !< return value
+    INTEGER, INTENT(OUT) ::  variable_id             !< variable ID
+#if defined( __netcdf4_parallel )
+    INTEGER              ::  parallel_access_mode    !< either NF90_INDEPENDENT or NF90_COLLECTIVE
+    INTEGER              ::  unlimited_dimension_id  !< ID of unlimited dimension in file
+#endif
     INTEGER, DIMENSION(:), INTENT(IN) ::  dimension_ids  !< list of dimension IDs used by variable
 
-    LOGICAL, INTENT(IN)  ::  is_global  !< true if variable is global (same on all PE)
+    LOGICAL, INTENT(IN) ::  write_only_by_master_rank  !< true if only master rank shall write variable
 
 
 #if defined( __netcdf4 )
     return_value = 0
-
-    WRITE( temp_string, * ) is_global
-    CALL internal_message( 'debug', routine_name //                                                &
-                           ': init variable "' // TRIM( variable_name ) //                         &
-                           '" ( is_global = ' // TRIM( temp_string ) // ')' )
-
-    nc_variable_type = get_netcdf_data_type( variable_type )
-
-    IF ( nc_variable_type /= -1 )  THEN
-!
-!--    Define variable in file
-       nc_stat = NF90_DEF_VAR( file_id, variable_name, nc_variable_type, dimension_ids, variable_id )
-
-!
-!--    Define how variable can be accessed by PEs in parallel netcdf file
-       IF ( nc_stat == NF90_NOERR  .AND.  TRIM( mode ) == mode_parallel )  THEN
+    variable_id = -1
+
+    IF ( ( TRIM( mode ) == mode_serial  .AND.  my_rank == master_rank )                            &
+         .OR.  TRIM( mode ) == mode_parallel )  THEN
+
+       WRITE( temp_string, * ) write_only_by_master_rank
+       CALL internal_message( 'debug', routine_name //                                             &
+                              ': init variable "' // TRIM( variable_name ) //                      &
+                              '" ( write_only_by_master_rank = ' // TRIM( temp_string ) // ')' )
+
+       nc_variable_type = get_netcdf_data_type( variable_type )
+
+       IF ( nc_variable_type /= -1 )  THEN
+!
+!--       Define variable in file
+          nc_stat = NF90_DEF_VAR( file_id, variable_name, nc_variable_type,                        &
+                                  dimension_ids, variable_id )
+
 #if defined( __netcdf4_parallel )
-          IF ( is_global )  THEN
-             nc_stat = NF90_VAR_PAR_ACCESS( file_id, variable_id, NF90_INDEPENDENT )
-          ELSE
-             nc_stat = NF90_VAR_PAR_ACCESS( file_id, variable_id, NF90_COLLECTIVE )
+!
+!--       Define how variable can be accessed by PEs in parallel netcdf file
+          IF ( nc_stat == NF90_NOERR  .AND.  TRIM( mode ) == mode_parallel )  THEN
+!
+!--          If the variable uses an unlimited dimension, its access mode must be 'collective',
+!--          otherwise it can be set to independent.
+!--          Hence, get ID of unlimited dimension in file (if any) and check if it is used by
+!--          the variable.
+             nc_stat = NF90_INQUIRE( file_id, UNLIMITEDDIMID=unlimited_dimension_id )
+
+             IF ( nc_stat == NF90_NOERR )  THEN
+                IF ( ANY( dimension_ids == unlimited_dimension_id ) )  THEN
+                   parallel_access_mode = NF90_COLLECTIVE
+                ELSE
+                   parallel_access_mode = NF90_INDEPENDENT
+                ENDIF
+
+                nc_stat = NF90_VAR_PAR_ACCESS( file_id, variable_id, parallel_access_mode )
+             ENDIF
           ENDIF
-#else
-          CONTINUE
-#endif
-       ENDIF
-
-       IF ( nc_stat /= NF90_NOERR )  THEN
+#endif
+
+          IF ( nc_stat /= NF90_NOERR )  THEN
+             return_value = 1
+             CALL internal_message( 'error', routine_name //                                       &
+                                    ': NetCDF error while initializing variable "' //              &
+                                    TRIM( variable_name ) // '": ' // NF90_STRERROR( nc_stat ) )
+          ENDIF
+
+       ELSE
           return_value = 1
-          CALL internal_message( 'error', routine_name //                                          &
-                                 ': NetCDF error while initializing variable "' //                 &
-                                 TRIM( variable_name ) // '": ' // NF90_STRERROR( nc_stat ) )
-       ENDIF
-
-    ELSE
+       ENDIF
+
+    ELSEIF ( TRIM( mode ) /= mode_serial  .AND.  TRIM( mode ) /= mode_parallel )  THEN
        return_value = 1
+       CALL internal_message( 'error', routine_name //                                             &
+                              ': selected mode "' // TRIM( mode ) // '" must be either "' //       &
+                              mode_serial // '" or "' // mode_parallel // '"' )
     ENDIF
 
@@ -461,4 +528,10 @@
     return_value = 1
     variable_id = -1
+!
+!-- Dummy commands to prevent "unused-variable" warning if preprocessor is not set
+    IF ( .FALSE. )  THEN
+       nc_stat = LEN( routine_name )
+       nc_variable_type = get_netcdf_data_type( '' )
+    ENDIF
 #endif
 
@@ -470,7 +543,9 @@
 !> Leave file definition state.
 !--------------------------------------------------------------------------------------------------!
- SUBROUTINE netcdf4_stop_file_header_definition( file_id, return_value )
+ SUBROUTINE netcdf4_stop_file_header_definition( mode, file_id, return_value )
 
     CHARACTER(LEN=*), PARAMETER ::  routine_name = 'netcdf4_stop_file_header_definition'  !< name of this routine
+
+    CHARACTER(LEN=*), INTENT(IN) ::  mode  !< operation mode (either parallel or serial)
 
     INTEGER, INTENT(IN)  ::  file_id        !< file ID
@@ -483,22 +558,32 @@
     return_value = 0
 
-    WRITE( temp_string, * ) file_id
-    CALL internal_message( 'debug', routine_name //                                                &
-                           ': finalize file definition (file_id=' // TRIM( temp_string ) // ')' )
-!
-!-- Set general no fill, otherwise the performance drops significantly
-    nc_stat = NF90_SET_FILL( file_id, NF90_NOFILL, old_fill_mode )
-
-    IF ( nc_stat == NF90_NOERR )  THEN
-       nc_stat = NF90_ENDDEF( file_id )
-    ENDIF
-
-    IF ( nc_stat /= NF90_NOERR )  THEN
-       return_value = 1
-       CALL internal_message( 'error', routine_name //                                             &
-                              ': NetCDF error: ' // NF90_STRERROR( nc_stat ) )
+    IF ( .NOT. ( TRIM( mode ) == mode_serial  .AND.  my_rank /= master_rank ) )  THEN
+
+       WRITE( temp_string, * ) file_id
+       CALL internal_message( 'debug', routine_name //                                             &
+                              ': finalize file definition (file_id=' // TRIM( temp_string ) // ')' )
+!
+!--    Set general no fill, otherwise the performance drops significantly
+       nc_stat = NF90_SET_FILL( file_id, NF90_NOFILL, old_fill_mode )
+
+       IF ( nc_stat == NF90_NOERR )  THEN
+          nc_stat = NF90_ENDDEF( file_id )
+       ENDIF
+
+       IF ( nc_stat /= NF90_NOERR )  THEN
+          return_value = 1
+          CALL internal_message( 'error', routine_name //                                          &
+                                 ': NetCDF error: ' // NF90_STRERROR( nc_stat ) )
+       ENDIF
+
     ENDIF
 #else
     return_value = 1
+!
+!-- Dummy commands to prevent "unused-variable" warning if preprocessor is not set
+    IF ( .FALSE. )  THEN
+       nc_stat = LEN( routine_name )
+       old_fill_mode = 0
+    ENDIF
 #endif
 
@@ -511,6 +596,6 @@
 !--------------------------------------------------------------------------------------------------!
  SUBROUTINE netcdf4_write_variable(                                                                &
-               file_id, variable_id, bounds_start, value_counts, bounds_origin,                    &
-               is_global,                                                                          &
+               mode, file_id, variable_id, bounds_start, value_counts, bounds_origin,              &
+               write_only_by_master_rank,                                                          &
                values_char_0d,   values_char_1d,   values_char_2d,   values_char_3d,               &
                values_int8_0d,   values_int8_1d,   values_int8_2d,   values_int8_3d,               &
@@ -525,4 +610,6 @@
     CHARACTER(LEN=*), PARAMETER ::  routine_name = 'netcdf4_write_variable'  !< name of this routine
 
+    CHARACTER(LEN=*), INTENT(IN) ::  mode  !< operation mode (either parallel or serial)
+
     CHARACTER(LEN=1), POINTER,             INTENT(IN), OPTIONAL                   ::  values_char_0d  !< output variable
     CHARACTER(LEN=1), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  values_char_1d  !< output variable
@@ -530,11 +617,11 @@
     CHARACTER(LEN=1), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  values_char_3d  !< output variable
 
-    INTEGER              ::  d             !< loop index
-    INTEGER, INTENT(IN)  ::  file_id       !< file ID
-    INTEGER              ::  my_rank       !< MPI rank of processor
-    INTEGER              ::  nc_stat       !< netcdf return value
-    INTEGER              ::  ndims         !< number of dimensions of variable in file
-    INTEGER, INTENT(OUT) ::  return_value  !< return value
-    INTEGER, INTENT(IN)  ::  variable_id   !< variable ID
+    INTEGER              ::  d                       !< loop index
+    INTEGER, INTENT(IN)  ::  file_id                 !< file ID
+    INTEGER              ::  nc_stat                 !< netcdf return value
+    INTEGER              ::  ndims                   !< number of dimensions of variable in file
+    INTEGER, INTENT(OUT) ::  return_value            !< return value
+    INTEGER              ::  unlimited_dimension_id  !< ID of unlimited dimension in file
+    INTEGER, INTENT(IN)  ::  variable_id             !< variable ID
 
     INTEGER, DIMENSION(:),              INTENT(IN)  ::  bounds_origin      !< starting index of each dimension
@@ -561,5 +648,6 @@
     INTEGER(iwp),    POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  values_intwp_3d  !< output variable
 
-    LOGICAL, INTENT(IN) ::  is_global  !< true if variable is global (same on all PE)
+    LOGICAL, INTENT(IN) ::  write_only_by_master_rank  !< true if only master rank shall write variable
+    LOGICAL             ::  write_data                 !< true if variable shall be written to file
 
     REAL(KIND=4), POINTER,             INTENT(IN), OPTIONAL                   ::  values_real32_0d  !< output variable
@@ -578,16 +666,44 @@
 
 #if defined( __netcdf4 )
-
-#if defined( __parallel )
-    CALL MPI_COMM_RANK( output_group_comm, my_rank, return_value )
-    IF ( return_value /= 0 )  THEN
-       CALL internal_message( 'error', routine_name // ': MPI_COMM_RANK error' )
-    ENDIF
-#else
-    my_rank = master_rank
     return_value = 0
-#endif
-
-    IF ( return_value == 0  .AND.  ( .NOT. is_global .OR. my_rank == master_rank ) )  THEN
+    write_data = .FALSE.
+!
+!-- Check whether this PE write any data to file
+    IF ( TRIM( mode ) == mode_serial )  THEN
+
+       IF ( my_rank == master_rank )  write_data = .TRUE.
+
+    ELSEIF ( TRIM( mode ) == mode_parallel )  THEN
+!
+!--    Check for collective access mode.
+!--    This cannot be checked directly but indirect via the presence of any unlimited dimensions
+!--    If any dimension is unlimited, variable access must be collective and all PEs must
+!--    participate in writing
+       ndims = SIZE( bounds_start )
+       ALLOCATE( dimension_ids(ndims) )
+
+       nc_stat = NF90_INQUIRE_VARIABLE( file_id, variable_id, DIMIDS=dimension_ids )
+       nc_stat = NF90_INQUIRE( file_id, UNLIMITEDDIMID=unlimited_dimension_id )
+
+       IF ( ANY( dimension_ids == unlimited_dimension_id ) )  THEN
+          write_data = .TRUE.
+!
+!--    If access is independent, check if only master rank shall write
+       ELSEIF ( write_only_by_master_rank )  THEN
+          IF ( my_rank == master_rank )  write_data = .TRUE.
+!
+!--    If all PEs can write, check if there are any data to be written
+       ELSEIF ( ALL( value_counts > 0, DIM=1 ) )  THEN
+          write_data = .TRUE.
+       ENDIF
+
+    ELSE
+       return_value = 1
+       CALL internal_message( 'error', routine_name //                                             &
+                              ': selected mode "' // TRIM( mode ) // '" must be either "' //       &
+                              mode_serial // '" or "' // mode_parallel // '"' )
+    ENDIF
+
+    IF ( write_data )  THEN
 
        WRITE( temp_string, * ) variable_id
@@ -595,7 +711,6 @@
 
        ndims = SIZE( bounds_start )
-
-!
-!--    character output
+!
+!--    Character output
        IF ( PRESENT( values_char_0d ) )  THEN
           nc_stat = NF90_PUT_VAR( file_id, variable_id, (/ values_char_0d /),                      &
@@ -723,5 +838,5 @@
                                   count = value_counts )
 !
-!--    working-precision real output
+!--    Working-precision real output
        ELSEIF ( PRESENT( values_realwp_0d ) )  THEN
           nc_stat = NF90_PUT_VAR( file_id, variable_id, (/ values_realwp_0d /),                    &
@@ -757,5 +872,5 @@
              WRITE( temp_string, * )  NF90_STRERROR( nc_stat )
 
-             ALLOCATE( dimension_ids(ndims) )
+             IF ( .NOT. ALLOCATED( dimension_ids ) )  ALLOCATE( dimension_ids(ndims) )
              ALLOCATE( dimension_lengths(ndims) )
 
@@ -793,4 +908,12 @@
 #else
     return_value = 1
+!
+!-- Dummy commands to prevent "unused-variable" warning if preprocessor is not set
+    IF ( .FALSE. )  THEN
+       nc_stat = LEN( routine_name )
+       IF ( write_data )  unlimited_dimension_id = 0
+       IF ( ALLOCATED( dimension_ids ) )  d = 0
+       IF ( ALLOCATED( dimension_lengths ) )  ndims = 0
+    ENDIF
 #endif
 
@@ -802,7 +925,9 @@
 !> Close netcdf file.
 !--------------------------------------------------------------------------------------------------!
- SUBROUTINE netcdf4_finalize( file_id, return_value )
+ SUBROUTINE netcdf4_finalize( mode, file_id, return_value )
 
     CHARACTER(LEN=*), PARAMETER ::  routine_name = 'netcdf4_finalize'  !< name of routine
+
+    CHARACTER(LEN=*), INTENT(IN) ::  mode  !< operation mode (either parallel or serial)
 
     INTEGER, INTENT(IN)  ::  file_id       !< file ID
@@ -812,18 +937,30 @@
 
 #if defined( __netcdf4 )
-    WRITE( temp_string, * ) file_id
-    CALL internal_message( 'debug', routine_name //                                                &
-                           ': close file (file_id=' // TRIM( temp_string ) // ')' )
-
-    nc_stat = NF90_CLOSE( file_id )
-    IF ( nc_stat == NF90_NOERR )  THEN
-       return_value = 0
-    ELSE
-       return_value = 1
-       CALL internal_message( 'error', routine_name //                                             &
-                              ': NetCDF error: ' // NF90_STRERROR( nc_stat ) )
+    return_value = 0
+
+    IF ( .NOT. ( TRIM( mode ) == mode_serial  .AND.  my_rank /= master_rank ) )  THEN
+
+       WRITE( temp_string, * ) file_id
+       CALL internal_message( 'debug', routine_name //                                             &
+                              ': close file (file_id=' // TRIM( temp_string ) // ')' )
+
+       nc_stat = NF90_CLOSE( file_id )
+       IF ( nc_stat == NF90_NOERR )  THEN
+          return_value = 0
+       ELSE
+          return_value = 1
+          CALL internal_message( 'error', routine_name //                                          &
+                                 ': NetCDF error: ' // NF90_STRERROR( nc_stat ) )
+       ENDIF
+
     ENDIF
 #else
     return_value = 1
+!
+!-- Dummy commands to prevent "unused-variable" warning if preprocessor is not set
+    IF ( .FALSE. )  THEN
+       nc_stat = 0
+       temp_string = routine_name
+    ENDIF
 #endif
 
